extern bool      UseTral=false;
extern double    lot    = 0.1;
extern int       TP     = 200;
extern int       SL     = 200;
extern int       FastMA=18;
extern int       SlowMA=28;
extern int       StopMA=55;
extern int       modema=1;
extern int       pricema=0;
extern int       TraillingStop=50;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
void CheakForOpen()
{
   double fasterMAnow = iMA(NULL, 0, FastMA, 0, modema, pricema,0),
          fasterMAprevious = iMA(NULL, 0, FastMA, 0, modema, pricema,1),
          slowerMAnow = iMA(NULL, 0, SlowMA, 0, modema, pricema,0),
          slowerMAprevious = iMA(NULL, 0, SlowMA, 0, modema, pricema,1);
   
   if ((fasterMAnow > slowerMAnow) && (fasterMAprevious < slowerMAprevious))//Buy
   {
      OrderSend(Symbol(),OP_BUY, lot,Ask,5,Bid-SL*Point,Ask+TP*Point,"",0,3);
   }
   
   else if ((fasterMAnow < slowerMAnow) && (fasterMAprevious > slowerMAprevious))//Sell
   {
      OrderSend(Symbol(),OP_SELL,lot,Bid,5,Ask+SL*Point,Bid-TP*Point,"",0,3);
   }
}
void TraillingPosition()
{
      double sm;
      sm = iMA(Symbol(),0,StopMA,0,modema,pricema,0);
      if(OrderSymbol()==Symbol())
      {
         if(OrderType()==OP_BUY)
         {
            if(OrderStopLoss()!=NormalizeDouble(sm - TraillingStop*Point,Digits))
            {
               ModifyStopLoss(NormalizeDouble(sm - TraillingStop*Point,Digits));
            }
         }
         if(OrderType()==OP_SELL)
         {
            if(OrderStopLoss()!=NormalizeDouble(sm + TraillingStop*Point,Digits))
            {
               ModifyStopLoss(NormalizeDouble(sm + TraillingStop*Point,Digits));
            }
         }
      }
}
void ModifyStopLoss(double ldStopLoss) 
  { 
   bool fm;
   fm = OrderModify(OrderTicket(), OrderOpenPrice(), ldStopLoss, OrderTakeProfit(), 
                    0, Gray);
   }
void start()
{
   for(int i=0; i<OrdersTotal(); i++)
      {
         if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES) && UseTral)
         {
            TraillingPosition();
         }
      }
      CheakForOpen();
      CheckForClose();
}
void CheckForClose()
{
   double fasterMAnow = iMA(NULL, 0, FastMA, 0, modema, pricema,0),
          fasterMAprevious = iMA(NULL, 0, FastMA, 0, modema, pricema,1),
          slowerMAnow = iMA(NULL, 0, SlowMA, 0, modema, pricema,0),
          slowerMAprevious = iMA(NULL, 0, SlowMA, 0, modema, pricema,1);
   if((fasterMAnow < slowerMAnow) && (fasterMAprevious > slowerMAprevious))
   {
      for(int i = 0; i < OrdersTotal(); i++)
      {
         if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
         {
            if (OrderSymbol()!=Symbol()) continue;
            if(OrderType()==OP_BUY) OrderClose(OrderTicket(),OrderLots(),MarketInfo(Symbol(),MODE_ASK),5,CLR_NONE);// Close Sell
         }   
      }
   }
   if((fasterMAnow > slowerMAnow) && (fasterMAprevious < slowerMAprevious))
   {
      for (i=OrdersTotal()-1; i>=0; i--)
      {                                               
         if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
         {
            if (OrderSymbol()!=Symbol()) continue;
            if(OrderType()==OP_SELL) OrderClose(OrderTicket(),OrderLots(),MarketInfo(Symbol(),MODE_ASK),5,CLR_NONE);// Close Sell
         }   
      }
   }
}